using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.SessionState;
using TallComponents.PDF.Rasterizer;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using TallComponents.PDF.Rasterizer.Configuration;

namespace AquaforestTIFFServerRender
{
    public class TIFFServerRender
    {

        public static void renderImage()
        {
            string FN="";
            string PC="";
            string WI = "";
            string HI = "";
            int pageNumber=0;
            int rotation = 0;
            int step = 0;
            Document pdfDoc;
            try
            {
                HttpContext.Current.Response.Clear();
                
                FN = HttpContext.Current.Request["FN"].ToString();
                if(HttpContext.Current.Request["PC"]!=null)
                {
                    PC = HttpContext.Current.Request["PC"].ToString();
                }
                if(HttpContext.Current.Request["PN"]!=null)
                {
                    try{pageNumber = int.Parse(HttpContext.Current.Request["PN"]) - 1;}catch {};
                }
                if (HttpContext.Current.Request["RO"] != null)
                {
                    try { rotation = int.Parse(HttpContext.Current.Request["RO"]); }
                    catch { };
                }
                if (HttpContext.Current.Request["WI"] != null)
                {
                    WI = HttpContext.Current.Request["WI"];
                }
                if (HttpContext.Current.Request["HI"] != null)
                {
                    HI = HttpContext.Current.Request["HI"];
                }
                using (FileStream file = new FileStream(FN, FileMode.Open, FileAccess.Read))
                {
                    step = 6;
                    byte[] buffer = new byte[file.Length];
                    step = 7;
                    file.Read(buffer, 0, buffer.Length);
                    step = 8;
                    pdfDoc = new Document(new BinaryReader(new MemoryStream(buffer)));
                    step = 9;
                    if (PC == "Y")
                    {
                        step = 10;
                        HttpContext.Current.Response.ContentType = "text/html";
                        HttpContext.Current.Response.Write("afPageCount=" + pdfDoc.Pages.Count + ";isJPEGTIFF=0;");

                    }
                    else
                    {
                        step = 1;
                        Page page = pdfDoc.Pages[pageNumber];

                      //create a raster image at 72 dpi
                        step = 2;
                     

                        // Determine Requested Size
                      int pwi = 0; try { pwi = (int)(decimal.Parse(WI)); }
                      catch { };
                      int phi = 0; try { phi = (int)decimal.Parse(HI); }
                      catch { };
                      if (pwi == 0)
                      {

                          pwi = (int) (page.Width * (phi * 1000 / page.Height)) / 1000;
                      }
                      if (phi == 0)
                      {

                          phi = (int) (page.Height * (pwi * 1000 / page.Width)) / 1000;

                      }
                      double imageAspect = page.Width / page.Height;
                      double windowAspect = pwi / phi;




                      if (windowAspect < imageAspect)
                      {
                          phi = (int)(page.Height * (pwi * 1000 / page.Width)) / 1000;
                          
                      }
                      else
                      {
                          pwi = (int)(page.Width * (phi * 1000 / page.Height)) / 1000;
                          
                      }

                      step = 3;


                      int dpi = 72;

                      Bitmap bitmap = null;
                    
                            bitmap=new Bitmap(pwi, phi);

                      Graphics graphics = Graphics.FromImage(bitmap);
                      
                      float scale = (float)pwi / (float)page.Width;

                      graphics.ScaleTransform(scale, scale);
                      graphics.SmoothingMode = SmoothingMode.AntiAlias;
                      // Makes it probably a bit slower, but gives the best result.
                      graphics.InterpolationMode = InterpolationMode.HighQualityBicubic;
                      RenderSettings renderSettings=new RenderSettings() ;
                      
                      renderSettings.ColorSettings.TransformationMode = ColorTransformationMode.HighQuality;
                        page.Draw(graphics, renderSettings);
                        if(rotation==90)
                            bitmap.RotateFlip(RotateFlipType.Rotate90FlipNone);
                        else
                        if (rotation == 180)
                            bitmap.RotateFlip(RotateFlipType.Rotate180FlipNone);
                        else
                        if (rotation == 270)
                            bitmap.RotateFlip(RotateFlipType.Rotate270FlipNone);

                     
                      step = 5;
                      bitmap.Save(HttpContext.Current.Response.OutputStream, ImageFormat.Gif);


                    }
                }
               


        }
        catch (Exception e)
        {
            HttpContext.Current.Response.Write("STEP "+step+"<BR>"+e.Message + "<BR>" + e.StackTrace);
            HttpContext.Current.Response.End();
        }
        HttpContext.Current.Response.End();
        }
    }
}
