#include "pilotControl.h"
#include <windows.h>
#include <stdio.h>

#define MAX_PATH 512 

namespace TIFFPilot
{

        static void unescape(char *buf);
        
        
        bool pilotControl::allowAccess()
        {
            char *query_string=getenv("QUERY_STRING");
            char *auth_user=getenv("USERNAME");
            char filename[MAX_PATH];
            char *filenamePtr;
	        bool allow=false;

            if(query_string!=NULL && query_string[0]!='\0') 
	        {
		        filenamePtr=strstr(query_string,"FN=");
                if(filenamePtr!=NULL)
                {
                    sscanf(filenamePtr,"FN=%4096[^&]", filename);
			        unescape(filename);
                }
            }
            
            // Determine Access - your code here

            // if OK to access
            allow=true;
			
            // otherwise
            //allow=false;

         

            if(allow)
            {
                return true;
            }
            else
            {
                fprintf(stdout,"Content-Type: text/html\r\n\r\n");
                fprintf(stdout,"Access Denied");
                return(false);
            }

        }


        bool pilotControl::silentMode()
        {
            // Return true to stop TIFF Pilot generating any error messages such as "Cannot Open..."
            return false;
        }
  


        void unescape(char *buf)
        {
            char *p=buf;

            while ((p=strchr(p,'+')))
            *p = ' ';

            p = buf;

            while (p && *p && (p=strchr(p,'%'))) 
            {
                int c1 = p[1];
                int c2 = p[2];

                if (c1 >= '0' && c1 <= '9')
                c1 = c1 - '0';
                else if (c1 >= 'A' && c1 <= 'F')
                c1 = 10 + c1 - 'A';
                else if (c1 >= 'a' && c1 <= 'f')
                c1 = 10 + c1 - 'a';
                else {p++; continue;}

                if (c2 >= '0' && c2 <= '9')
                c2 = c2 - '0';
                else if (c2 >= 'A' && c2 <= 'F')
                c2 = 10 + c2 - 'A';
                else if (c2 >= 'a' && c2 <= 'f')
                c2 = 10 + c2 - 'a';
                else 
                {
                    p++; continue;
                }
                *p = (c1<<4) | c2;
                memcpy(p+1, p+3, strlen(p+3)+1);
                p++;
            }
        }
}